<?php
@session_start();

require_once('config.php');
require_once('smarty/libs/Smarty.class.php');
require_once('lang.php');

define_syslog_variables();
openlog('MyPASS', LOG_PID | LOG_PERROR, LOG_LOCAL0);

$smarty = new Smarty();
$smarty->template_dir = '';
$smarty->compile_dir = 'templates_c/';
$smarty->config_dir = '';
$smarty->cache_dir = '';
$smarty->left_delimiter = '<{';
$smarty->right_delimiter = '}>';

if (count($_POST) == 0) ShowMenu('', '');

// check username
$username = isset($_POST['username']) ? $_POST['username'] : '';
if (!isset($username) || empty($username)) ShowMenu($lang['ERROR_USERNAME'], $username);
// check allowed user
if (!isset($aAllowUser[$username]) || $aAllowUser[$username] !== $username) ShowMenu($lang['ERROR_USER_NOT_ALLOW'], $username);

// check old password
$old_password = isset($_POST['old_password']) ? $_POST['old_password'] : '';
if (!isset($old_password) || empty($old_password)) ShowMenu($lang['ERROR_OLDPASSWORD'], $username);

// check new_password
$new_password = isset($_POST['new_password']) ? $_POST['new_password'] : '';
if (!isset($new_password) || empty($new_password)) ShowMenu($lang['ERROR_NEWPASSWORD'], $username);

// check new_password again
$new_password_confirm = isset($_POST['new_password_confirm']) ? $_POST['new_password_confirm'] : '';
if ($new_password !== $new_password_confirm) ShowMenu($lang['ERROR_NEWPASSWORD_CONFIRM'], $username);

// check timestamp
$timestamp = isset($_POST['timestamp']) ? $_POST['timestamp'] : '';
if (!isset($timestamp) || empty($timestamp)) ShowMenu($lang['ERROR_TIMESTAMP'], $username);
$now = time();
if ($timestamp > $now)
    $len = $timestamp;
else
    $len = $now - $timestamp;
// over 1 hour
if ($len > 3600) ShowMenu($lang['ERROR_TIMESTAMP_TIMEOUT'], $username);

$code = md5(ANTISPAM_CODE.strftime('%D %T', $timestamp));
$correct_ans = isset($_POST['antibot_'.$code]) ? $_POST['antibot_'.$code] : '';

$ans1 = md5(ANTISPAM_ANS1.strftime('%D %T', $timestamp).ANTISPAM_CODE);
$ans2 = md5(ANTISPAM_CODE.strftime('%D %T', $timestamp).ANTISPAM_ANS2);

if ($correct_ans === $ans1) {
    $answer_1 = isset($_POST['answer_1']) ? $_POST['answer_1'] : '';
    if ($answer_1 !== 'on' || isset($_POST['answer_2'])) ShowMenu($lang['ERROR_CHECKBOX_ERROR'], $username);
}
else if ($correct_ans === $ans2) {
    $answer_2 = isset($_POST['answer_2']) ? $_POST['answer_2'] : '';
    if ($answer_2 !== 'on' || isset($_POST['answer_1'])) ShowMenu($lang['ERROR_CHECKBOX_ERROR'], $username);
}
else {
    ShowMenu($lang['ERROR_CHECKBOX_ERROR'], $username);
}

syslog(LOG_INFO, "try to change password for $username");

// the data look good, try to change password
$fp = fsockopen($poppassd_host, $poppassd_port, $err_no, $err_str, 30);
if (!$fp) {
    ShowMenu($lang['ERROR_CONNECT'].$err_str, $username);
}
$prompt = fgets($fp, 4096);
if (substr($prompt, 0, 3) != '200') {
    fputs($fp, "quit\n");
    fclose($fp);
    ShowMenu($lang['ERROR_CONNECT_ERROR'].$prompt, $username);
}

fputs($fp, "user $username\n");
$prompt = fgets($fp, 4096);
if (substr($prompt, 0, 3) != '200') {
    fputs($fp, "quit\n");
    fclose($fp);
    ShowMenu($lang['ERROR_USER_ERROR'].$prompt, $username);
}

fputs($fp, "pass $old_password\n");
$prompt = fgets($fp, 4096);
if (substr($prompt, 0, 3) != '200') {
    fputs($fp, "quit\n");
    fclose($fp);
    ShowMenu($lang['ERROR_PASS_ERROR'].$prompt, $username);
}

fputs($fp, "newpass $new_password\n");
$prompt = fgets($fp, 4096);
if (substr($prompt, 0, 3) != '200') {
    fputs($fp, "quit\n");
    fclose($fp);
    ShowMenu($lang['ERROR_NEWPASS_ERROR'].$prompt, $username);
}

fputs($fp, "quit\n");
fclose($fp);

syslog(LOG_INFO, "successful to change password for $username");

ShowMenu($lang['ERROR_NEWPASS_OK'].$prompt, $username);
exit;

function ShowMenu($message, $username)
{
    global $smarty, $lang;

    if ($message !== '') {
        $smarty->assign(array(
                'ERROR_MESSAGE' => $message,
                'ERROR_BEGIN' => '',
                'ERROR_END' => '',
                ));
    }
    else {
        $smarty->assign(array(
                'ERROR_MESSAGE' => '',
                'ERROR_BEGIN' => '<!--',
                'ERROR_END' => '-->',
                ));
    }

    $timestamp = time();
    $code = md5(ANTISPAM_CODE.strftime('%D %T', $timestamp));
    $antibot_name = 'antibot_'.$code;

    $x = rand(0, 99) % 2;
    if ($x == 0) {
        $antibot_value = md5(ANTISPAM_ANS1.strftime('%D %T', $timestamp).ANTISPAM_CODE);
        $ans1 = $lang['DESC_MUST_CHOOSE'];
        $ans2 = $lang['DESC_MUST_NOTCHOOSE'];
    }
    else {
        $antibot_value = md5(ANTISPAM_CODE.strftime('%D %T', $timestamp).ANTISPAM_ANS2);
        $ans1 = $lang['DESC_MUST_NOTCHOOSE'];
        $ans2 = $lang['DESC_MUST_CHOOSE'];
    }

    $smarty->assign(array(
            'ENCODING' => ENCODING,
            'VERSION' => VERSION,
            'LANG' => $lang['LANG'],
            'TITLE' => $lang['TITLE'],
            'DESC_MYPASS' => $lang['TITLE'],
            'DESC_USER' => $lang['DESC_USER'],
            'USERNAME' => $username,
            'DESC_OLDPASS' => $lang['DESC_OLDPASS'],
            'DESC_NEWPASS' => $lang['DESC_NEWPASS'],
            'DESC_NEWPASS_CONFIRM' => $lang['DESC_NEWPASS_CONFIRM'],
            'TIMESTAMP' => $timestamp,
            'ANTIBOT_NAME' => $antibot_name,
            'ANTIBOT_VALUE' => $antibot_value,
            'DESC_ANS1' => $ans1,
            'DESC_ANS2' => $ans2,
            'DESC_SUBMIT_BTN' => $lang['DESC_SUBMIT_BTN'],
            'DESC_RESET_BTN' => $lang['DESC_RESET_BTN'],
            ));
    $smarty->display('index.tpl');
    closelog();
    exit;
}

?>
